--[[

	Soundwave
	by Ailae of Emeriss-EU
	
]]

local addon, Soundwave = ...
local base = "#showtooltip\n/cast [btn:1] <SPELL>\n/stopmacro [btn:1]\n/run DismissCompanion(\"CRITTER\")"

function Soundwave:COMPANION_UPDATE(k)
	if k ~= "CRITTER" then return end
	if InCombatLockdown() then self:RegisterEvent("PLAYER_REGEN_ENABLED") return end
	if GetNumCompanions("CRITTER") == 0 then return end
	
	local spell, petindex
	if #SoundwaveDB > 1 then
		petindex = math.random(1, #SoundwaveDB)
		-- don't want the same again, gawd
		if self.current and petindex == self.current then
			while petindex == self.current do
				petindex = math.random(1, #SoundwaveDB)
			end
		end
		spell = select(3, GetCompanionInfo("CRITTER", SoundwaveDB[petindex]))
	else
		petindex = SoundwaveDB[1] or 1
		spell = select(3, GetCompanionInfo("CRITTER", petindex))
	end
	
	self.current = petindex
	
	local spellName = GetSpellInfo(spell)
	local macro = string.gsub(base, "<SPELL>", spellName)
	EditMacro(GetMacroIndexByName("Soundwave"), "Soundwave", nil, macro)
end

function Soundwave:PLAYER_REGEN_ENABLED()
	self:UnregisterEvent("PLAYER_REGEN_ENABLED")
	self:COMPANION_UPDATE("CRITTER")
end

function Soundwave:PLAYER_LOGIN()
	if not GetMacroInfo("Soundwave") then
		CreateMacro("Soundwave", 1, base, 1)
	end
	SoundwaveDB = SoundwaveDB or {}

	self:RegisterEvent("COMPANION_UPDATE")
	self:COMPANION_UPDATE("CRITTER")
	
	SLASH_Soundwave1 = "/swave"
	SLASH_Soundwave2 = "/soundwave"
	SlashCmdList.Soundwave = function() Soundwave.GUI:Show() end
end

Soundwave.frame = CreateFrame("Frame", nil, UIParent)
Soundwave.frame:SetScript("OnEvent", function(self, event, ...) return Soundwave[event] and Soundwave[event](Soundwave, ...) end)

function Soundwave:RegisterEvent(event) return self.frame:RegisterEvent(event) end
function Soundwave:UnregisterEvent(event) return self.frame:UnregisterEvent(event) end

Soundwave:RegisterEvent("PLAYER_LOGIN")
